// raunanje pi = 4*(1- 1/3 + 1/5 - 1/7 + ....)
// nitke, pravilno
// delovanje niti nadziramo z argumeni, enostavneje je, e nam preko argumentov
// (klic po referenci) nit vrednosti tudi vraa
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <pthread.h>

#define N 1000000
#define NTHREADS 3

struct params
{
	int myrank;
	double mypi;
};

double pi;
int lock;

void *thread_sum(void *arg)
{
	int i, sign;
	struct params *a = (struct params *)arg;
	int rank = (*a).myrank;
	int start = (int)(N/(double)NTHREADS*rank);
	int stop = (int)(N/(double)NTHREADS*(rank+1));

	if( start%2 == 0)
		sign = 1;
	else 
		sign = -1;
	for(i=start; i<stop; i++, sign = -sign)
		a->mypi += sign*4.0/(2*i+1);

	return NULL;
}

int main(void)
{
	int i;
	pthread_t t[NTHREADS];
	struct params p[NTHREADS];

	pi = 0.0;

	for(i=0; i<NTHREADS; i++)
	{
		p[i].myrank = i;
		p[i].mypi = 0.0;
		pthread_create(&t[i], NULL, thread_sum, (void *)&p[i]);
	}

	for(i=0; i<NTHREADS; i++)
	{
		pthread_join(t[i], NULL);
		pi += p[i].mypi;
	}

	printf("pi = %lf\n", pi);

	return 0;
}
