// raunanje pi = 4*(1- 1/3 + 1/5 - 1/7 + ....)
// nitke, pravilno
// v primeru, da moramo kritini del programa zaklepati, to najuinkoviteje naredimo
// s kljuavnicami - e kljuavnica ni zaklenjena, jo lahko odklene poljubna nit;
// v primeru, da je kljuavnica zaklenjena, sistem ustavi izvajanje niti, nit ne 
// porablja procesorskih virov
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <pthread.h>

#define N 1000000
#define NTHREADS 5

double pi;
pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;

void *thread_sum(void *arg)
{
	int i, sign;
	int rank = (int)arg;
	int start = (int)(N/(double)NTHREADS*rank);
	int stop = (int)(N/(double)NTHREADS*(rank+1));

	if( start%2 == 0)
		sign = 1;
	else 
		sign = -1;
	for(i=start; i<stop; i++, sign = -sign)
	{
		pthread_mutex_lock(&lock);
		pi += sign*4.0/(2*i+1);
		pthread_mutex_unlock(&lock);
	}

	return NULL;
}

int main(void)
{
	int i;
	pthread_t t[NTHREADS];

	pi = 0.0;

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, thread_sum, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	printf("pi = %lf\n", pi);

	return 0;
}
